// Code generated by protoc-gen-go. DO NOT EDIT.
// source: envoy/api/v2/auth/cert.proto

package auth

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import envoy_api_v2_core "github.com/cilium/cilium/pkg/envoy/envoy/api/v2/core"
import envoy_api_v2_core2 "github.com/cilium/cilium/pkg/envoy/envoy/api/v2/core"
import google_protobuf1 "github.com/golang/protobuf/ptypes/wrappers"
import _ "github.com/lyft/protoc-gen-validate/validate"
import _ "github.com/gogo/protobuf/gogoproto"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

type TlsParameters_TlsProtocol int32

const (
	// Envoy will choose the optimal TLS version.
	TlsParameters_TLS_AUTO TlsParameters_TlsProtocol = 0
	// TLS 1.0
	TlsParameters_TLSv1_0 TlsParameters_TlsProtocol = 1
	// TLS 1.1
	TlsParameters_TLSv1_1 TlsParameters_TlsProtocol = 2
	// TLS 1.2
	TlsParameters_TLSv1_2 TlsParameters_TlsProtocol = 3
	// TLS 1.3
	TlsParameters_TLSv1_3 TlsParameters_TlsProtocol = 4
)

var TlsParameters_TlsProtocol_name = map[int32]string{
	0: "TLS_AUTO",
	1: "TLSv1_0",
	2: "TLSv1_1",
	3: "TLSv1_2",
	4: "TLSv1_3",
}
var TlsParameters_TlsProtocol_value = map[string]int32{
	"TLS_AUTO": 0,
	"TLSv1_0":  1,
	"TLSv1_1":  2,
	"TLSv1_2":  3,
	"TLSv1_3":  4,
}

func (x TlsParameters_TlsProtocol) String() string {
	return proto.EnumName(TlsParameters_TlsProtocol_name, int32(x))
}
func (TlsParameters_TlsProtocol) EnumDescriptor() ([]byte, []int) { return fileDescriptor1, []int{0, 0} }

type TlsParameters struct {
	// Minimum TLS protocol version.
	TlsMinimumProtocolVersion TlsParameters_TlsProtocol `protobuf:"varint,1,opt,name=tls_minimum_protocol_version,json=tlsMinimumProtocolVersion,enum=envoy.api.v2.auth.TlsParameters_TlsProtocol" json:"tls_minimum_protocol_version,omitempty"`
	// Maximum TLS protocol version.
	TlsMaximumProtocolVersion TlsParameters_TlsProtocol `protobuf:"varint,2,opt,name=tls_maximum_protocol_version,json=tlsMaximumProtocolVersion,enum=envoy.api.v2.auth.TlsParameters_TlsProtocol" json:"tls_maximum_protocol_version,omitempty"`
	// If specified, the TLS listener will only support the specified `cipher list
	// <https://commondatastorage.googleapis.com/chromium-boringssl-docs/ssl.h.html#Cipher-suite-configuration>`_.
	// If not specified, the default list:
	//
	// .. code-block:: none
	//
	//   [ECDHE-ECDSA-AES128-GCM-SHA256|ECDHE-ECDSA-CHACHA20-POLY1305]
	//   [ECDHE-RSA-AES128-GCM-SHA256|ECDHE-RSA-CHACHA20-POLY1305]
	//   ECDHE-ECDSA-AES128-SHA256
	//   ECDHE-RSA-AES128-SHA256
	//   ECDHE-ECDSA-AES128-SHA
	//   ECDHE-RSA-AES128-SHA
	//   AES128-GCM-SHA256
	//   AES128-SHA256
	//   AES128-SHA
	//   ECDHE-ECDSA-AES256-GCM-SHA384
	//   ECDHE-RSA-AES256-GCM-SHA384
	//   ECDHE-ECDSA-AES256-SHA384
	//   ECDHE-RSA-AES256-SHA384
	//   ECDHE-ECDSA-AES256-SHA
	//   ECDHE-RSA-AES256-SHA
	//   AES256-GCM-SHA384
	//   AES256-SHA256
	//   AES256-SHA
	//
	// will be used.
	CipherSuites []string `protobuf:"bytes,3,rep,name=cipher_suites,json=cipherSuites" json:"cipher_suites,omitempty"`
	// If specified, the TLS connection will only support the specified ECDH
	// curves. If not specified, the default curves (X25519, P-256) will be used.
	EcdhCurves []string `protobuf:"bytes,4,rep,name=ecdh_curves,json=ecdhCurves" json:"ecdh_curves,omitempty"`
}

func (m *TlsParameters) Reset()                    { *m = TlsParameters{} }
func (m *TlsParameters) String() string            { return proto.CompactTextString(m) }
func (*TlsParameters) ProtoMessage()               {}
func (*TlsParameters) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{0} }

func (m *TlsParameters) GetTlsMinimumProtocolVersion() TlsParameters_TlsProtocol {
	if m != nil {
		return m.TlsMinimumProtocolVersion
	}
	return TlsParameters_TLS_AUTO
}

func (m *TlsParameters) GetTlsMaximumProtocolVersion() TlsParameters_TlsProtocol {
	if m != nil {
		return m.TlsMaximumProtocolVersion
	}
	return TlsParameters_TLS_AUTO
}

func (m *TlsParameters) GetCipherSuites() []string {
	if m != nil {
		return m.CipherSuites
	}
	return nil
}

func (m *TlsParameters) GetEcdhCurves() []string {
	if m != nil {
		return m.EcdhCurves
	}
	return nil
}

type TlsCertificate struct {
	// The TLS certificate chain.
	CertificateChain *envoy_api_v2_core.DataSource `protobuf:"bytes,1,opt,name=certificate_chain,json=certificateChain" json:"certificate_chain,omitempty"`
	// The TLS private key.
	PrivateKey *envoy_api_v2_core.DataSource `protobuf:"bytes,2,opt,name=private_key,json=privateKey" json:"private_key,omitempty"`
	// [#not-implemented-hide:]
	Password *envoy_api_v2_core.DataSource `protobuf:"bytes,3,opt,name=password" json:"password,omitempty"`
	// [#not-implemented-hide:]
	OcspStaple *envoy_api_v2_core.DataSource `protobuf:"bytes,4,opt,name=ocsp_staple,json=ocspStaple" json:"ocsp_staple,omitempty"`
	// [#not-implemented-hide:]
	SignedCertificateTimestamp []*envoy_api_v2_core.DataSource `protobuf:"bytes,5,rep,name=signed_certificate_timestamp,json=signedCertificateTimestamp" json:"signed_certificate_timestamp,omitempty"`
}

func (m *TlsCertificate) Reset()                    { *m = TlsCertificate{} }
func (m *TlsCertificate) String() string            { return proto.CompactTextString(m) }
func (*TlsCertificate) ProtoMessage()               {}
func (*TlsCertificate) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{1} }

func (m *TlsCertificate) GetCertificateChain() *envoy_api_v2_core.DataSource {
	if m != nil {
		return m.CertificateChain
	}
	return nil
}

func (m *TlsCertificate) GetPrivateKey() *envoy_api_v2_core.DataSource {
	if m != nil {
		return m.PrivateKey
	}
	return nil
}

func (m *TlsCertificate) GetPassword() *envoy_api_v2_core.DataSource {
	if m != nil {
		return m.Password
	}
	return nil
}

func (m *TlsCertificate) GetOcspStaple() *envoy_api_v2_core.DataSource {
	if m != nil {
		return m.OcspStaple
	}
	return nil
}

func (m *TlsCertificate) GetSignedCertificateTimestamp() []*envoy_api_v2_core.DataSource {
	if m != nil {
		return m.SignedCertificateTimestamp
	}
	return nil
}

type TlsSessionTicketKeys struct {
	// Keys for encrypting and decrypting TLS session tickets. The
	// first key in the array contains the key to encrypt all new sessions created by this context.
	// All keys are candidates for decrypting received tickets. This allows for easy rotation of keys
	// by, for example, putting the new key first, and the previous key second.
	//
	// If :ref:`session_ticket_keys <envoy_api_field_auth.DownstreamTlsContext.session_ticket_keys>`
	// is not specified, the TLS library will still support resuming sessions via tickets, but it will
	// use an internally-generated and managed key, so sessions cannot be resumed across hot restarts
	// or on different hosts.
	//
	// Each key must contain exactly 80 bytes of cryptographically-secure random data. For
	// example, the output of ``openssl rand 80``.
	//
	// .. attention::
	//
	//   Using this feature has serious security considerations and risks. Improper handling of keys
	//   may result in loss of secrecy in connections, even if ciphers supporting perfect forward
	//   secrecy are used. See https://www.imperialviolet.org/2013/06/27/botchingpfs.html for some
	//   discussion. To minimize the risk, you must:
	//
	//   * Keep the session ticket keys at least as secure as your TLS certificate private keys
	//   * Rotate session ticket keys at least daily, and preferably hourly
	//   * Always generate keys using a cryptographically-secure random data source
	Keys []*envoy_api_v2_core.DataSource `protobuf:"bytes,1,rep,name=keys" json:"keys,omitempty"`
}

func (m *TlsSessionTicketKeys) Reset()                    { *m = TlsSessionTicketKeys{} }
func (m *TlsSessionTicketKeys) String() string            { return proto.CompactTextString(m) }
func (*TlsSessionTicketKeys) ProtoMessage()               {}
func (*TlsSessionTicketKeys) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{2} }

func (m *TlsSessionTicketKeys) GetKeys() []*envoy_api_v2_core.DataSource {
	if m != nil {
		return m.Keys
	}
	return nil
}

type CertificateValidationContext struct {
	// TLS certificate data containing certificate authority certificates to use in verifying
	// a presented peer certificate (e.g. server certificate for clusters or client certificate
	// for listeners). If not specified and a peer certificate is presented it will not be
	// verified. By default, a client certificate is optional, unless one of the additional
	// options (:ref:`require_client_certificate
	// <envoy_api_field_auth.DownstreamTlsContext.require_client_certificate>`,
	// :ref:`verify_certificate_hash
	// <envoy_api_field_auth.CertificateValidationContext.verify_certificate_hash>`, or
	// :ref:`verify_subject_alt_name
	// <envoy_api_field_auth.CertificateValidationContext.verify_subject_alt_name>`) is also
	// specified.
	//
	// See :ref:`the TLS overview <arch_overview_ssl_enabling_verification>` for a list of common
	// system CA locations.
	TrustedCa *envoy_api_v2_core.DataSource `protobuf:"bytes,1,opt,name=trusted_ca,json=trustedCa" json:"trusted_ca,omitempty"`
	// If specified, Envoy will verify (pin) the hex-encoded SHA-256 hash of
	// the presented certificate.
	VerifyCertificateHash []string `protobuf:"bytes,2,rep,name=verify_certificate_hash,json=verifyCertificateHash" json:"verify_certificate_hash,omitempty"`
	// If specified, Envoy will verify (pin) base64-encoded SHA-256 hash of
	// the Subject Public Key Information (SPKI) of the presented certificate.
	// This is the same format as used in HTTP Public Key Pinning.
	// [#not-implemented-hide:]
	VerifySpkiSha256 []string `protobuf:"bytes,3,rep,name=verify_spki_sha256,json=verifySpkiSha256" json:"verify_spki_sha256,omitempty"`
	// An optional list of subject alternative names. If specified, Envoy will verify that
	// the certificate’s subject alternative name matches one of the specified values.
	VerifySubjectAltName []string `protobuf:"bytes,4,rep,name=verify_subject_alt_name,json=verifySubjectAltName" json:"verify_subject_alt_name,omitempty"`
	// [#not-implemented-hide:] Must present a signed time-stamped OCSP response.
	RequireOcspStaple *google_protobuf1.BoolValue `protobuf:"bytes,5,opt,name=require_ocsp_staple,json=requireOcspStaple" json:"require_ocsp_staple,omitempty"`
	// [#not-implemented-hide:] Must present signed certificate time-stamp.
	RequireSignedCertificateTimestamp *google_protobuf1.BoolValue `protobuf:"bytes,6,opt,name=require_signed_certificate_timestamp,json=requireSignedCertificateTimestamp" json:"require_signed_certificate_timestamp,omitempty"`
	// An optional `certificate revocation list
	// <http://https://en.wikipedia.org/wiki/Certificate_revocation_list>`_
	// (in PEM format). If specified, Envoy will verify that the presented peer
	// certificate has not been revoked by this CRL. If this DataSource contains
	// multiple CRLs, all of them will be used.
	Crl *envoy_api_v2_core.DataSource `protobuf:"bytes,7,opt,name=crl" json:"crl,omitempty"`
}

func (m *CertificateValidationContext) Reset()                    { *m = CertificateValidationContext{} }
func (m *CertificateValidationContext) String() string            { return proto.CompactTextString(m) }
func (*CertificateValidationContext) ProtoMessage()               {}
func (*CertificateValidationContext) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{3} }

func (m *CertificateValidationContext) GetTrustedCa() *envoy_api_v2_core.DataSource {
	if m != nil {
		return m.TrustedCa
	}
	return nil
}

func (m *CertificateValidationContext) GetVerifyCertificateHash() []string {
	if m != nil {
		return m.VerifyCertificateHash
	}
	return nil
}

func (m *CertificateValidationContext) GetVerifySpkiSha256() []string {
	if m != nil {
		return m.VerifySpkiSha256
	}
	return nil
}

func (m *CertificateValidationContext) GetVerifySubjectAltName() []string {
	if m != nil {
		return m.VerifySubjectAltName
	}
	return nil
}

func (m *CertificateValidationContext) GetRequireOcspStaple() *google_protobuf1.BoolValue {
	if m != nil {
		return m.RequireOcspStaple
	}
	return nil
}

func (m *CertificateValidationContext) GetRequireSignedCertificateTimestamp() *google_protobuf1.BoolValue {
	if m != nil {
		return m.RequireSignedCertificateTimestamp
	}
	return nil
}

func (m *CertificateValidationContext) GetCrl() *envoy_api_v2_core.DataSource {
	if m != nil {
		return m.Crl
	}
	return nil
}

// TLS context shared by both client and server TLS contexts.
type CommonTlsContext struct {
	// TLS protocol versions, cipher suites etc.
	TlsParams *TlsParameters `protobuf:"bytes,1,opt,name=tls_params,json=tlsParams" json:"tls_params,omitempty"`
	// Multiple TLS certificates can be associated with the same context.
	// E.g. to allow both RSA and ECDSA certificates, two TLS certificates can be configured.
	//
	// .. attention::
	//
	//   Although this is a list, currently only a single certificate is supported. This will be
	//   relaxed in the future.
	TlsCertificates []*TlsCertificate `protobuf:"bytes,2,rep,name=tls_certificates,json=tlsCertificates" json:"tls_certificates,omitempty"`
	// [#not-implemented-hide:]
	TlsCertificateSdsSecretConfigs []*SdsSecretConfig `protobuf:"bytes,6,rep,name=tls_certificate_sds_secret_configs,json=tlsCertificateSdsSecretConfigs" json:"tls_certificate_sds_secret_configs,omitempty"`
	// How to validate peer certificates.
	ValidationContext *CertificateValidationContext `protobuf:"bytes,3,opt,name=validation_context,json=validationContext" json:"validation_context,omitempty"`
	// Supplies the list of ALPN protocols that the listener should expose. In
	// practice this is likely to be set to one of two values (see the
	// :ref:`codec_type <config_http_conn_man_codec_type>` parameter in the HTTP connection
	// manager for more information):
	//
	// * "h2,http/1.1" If the listener is going to support both HTTP/2 and HTTP/1.1.
	// * "http/1.1" If the listener is only going to support HTTP/1.1.
	//
	// There is no default for this parameter. If empty, Envoy will not expose ALPN.
	AlpnProtocols []string `protobuf:"bytes,4,rep,name=alpn_protocols,json=alpnProtocols" json:"alpn_protocols,omitempty"`
	// [#not-implemented-hide:]
	DeprecatedV1 *CommonTlsContext_DeprecatedV1 `protobuf:"bytes,5,opt,name=deprecated_v1,json=deprecatedV1" json:"deprecated_v1,omitempty"`
}

func (m *CommonTlsContext) Reset()                    { *m = CommonTlsContext{} }
func (m *CommonTlsContext) String() string            { return proto.CompactTextString(m) }
func (*CommonTlsContext) ProtoMessage()               {}
func (*CommonTlsContext) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{4} }

func (m *CommonTlsContext) GetTlsParams() *TlsParameters {
	if m != nil {
		return m.TlsParams
	}
	return nil
}

func (m *CommonTlsContext) GetTlsCertificates() []*TlsCertificate {
	if m != nil {
		return m.TlsCertificates
	}
	return nil
}

func (m *CommonTlsContext) GetTlsCertificateSdsSecretConfigs() []*SdsSecretConfig {
	if m != nil {
		return m.TlsCertificateSdsSecretConfigs
	}
	return nil
}

func (m *CommonTlsContext) GetValidationContext() *CertificateValidationContext {
	if m != nil {
		return m.ValidationContext
	}
	return nil
}

func (m *CommonTlsContext) GetAlpnProtocols() []string {
	if m != nil {
		return m.AlpnProtocols
	}
	return nil
}

func (m *CommonTlsContext) GetDeprecatedV1() *CommonTlsContext_DeprecatedV1 {
	if m != nil {
		return m.DeprecatedV1
	}
	return nil
}

// These fields are deprecated and only are used during the interim v1 -> v2
// transition period for internal purposes. They should not be used outside of
// the Envoy binary. [#not-implemented-hide:]
type CommonTlsContext_DeprecatedV1 struct {
	AltAlpnProtocols string `protobuf:"bytes,1,opt,name=alt_alpn_protocols,json=altAlpnProtocols" json:"alt_alpn_protocols,omitempty"`
}

func (m *CommonTlsContext_DeprecatedV1) Reset()         { *m = CommonTlsContext_DeprecatedV1{} }
func (m *CommonTlsContext_DeprecatedV1) String() string { return proto.CompactTextString(m) }
func (*CommonTlsContext_DeprecatedV1) ProtoMessage()    {}
func (*CommonTlsContext_DeprecatedV1) Descriptor() ([]byte, []int) {
	return fileDescriptor1, []int{4, 0}
}

func (m *CommonTlsContext_DeprecatedV1) GetAltAlpnProtocols() string {
	if m != nil {
		return m.AltAlpnProtocols
	}
	return ""
}

type UpstreamTlsContext struct {
	// Common TLS context settings.
	CommonTlsContext *CommonTlsContext `protobuf:"bytes,1,opt,name=common_tls_context,json=commonTlsContext" json:"common_tls_context,omitempty"`
	// SNI string to use when creating TLS backend connections.
	Sni string `protobuf:"bytes,2,opt,name=sni" json:"sni,omitempty"`
}

func (m *UpstreamTlsContext) Reset()                    { *m = UpstreamTlsContext{} }
func (m *UpstreamTlsContext) String() string            { return proto.CompactTextString(m) }
func (*UpstreamTlsContext) ProtoMessage()               {}
func (*UpstreamTlsContext) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{5} }

func (m *UpstreamTlsContext) GetCommonTlsContext() *CommonTlsContext {
	if m != nil {
		return m.CommonTlsContext
	}
	return nil
}

func (m *UpstreamTlsContext) GetSni() string {
	if m != nil {
		return m.Sni
	}
	return ""
}

type DownstreamTlsContext struct {
	// Common TLS context settings.
	CommonTlsContext *CommonTlsContext `protobuf:"bytes,1,opt,name=common_tls_context,json=commonTlsContext" json:"common_tls_context,omitempty"`
	// If specified, Envoy will reject connections without a valid client
	// certificate.
	RequireClientCertificate *google_protobuf1.BoolValue `protobuf:"bytes,2,opt,name=require_client_certificate,json=requireClientCertificate" json:"require_client_certificate,omitempty"`
	// If specified, Envoy will reject connections without a valid and matching SNI.
	// [#not-implemented-hide:]
	RequireSni *google_protobuf1.BoolValue `protobuf:"bytes,3,opt,name=require_sni,json=requireSni" json:"require_sni,omitempty"`
	// Types that are valid to be assigned to SessionTicketKeysType:
	//	*DownstreamTlsContext_SessionTicketKeys
	//	*DownstreamTlsContext_SessionTicketKeysSdsSecretConfig
	SessionTicketKeysType isDownstreamTlsContext_SessionTicketKeysType `protobuf_oneof:"session_ticket_keys_type"`
}

func (m *DownstreamTlsContext) Reset()                    { *m = DownstreamTlsContext{} }
func (m *DownstreamTlsContext) String() string            { return proto.CompactTextString(m) }
func (*DownstreamTlsContext) ProtoMessage()               {}
func (*DownstreamTlsContext) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{6} }

type isDownstreamTlsContext_SessionTicketKeysType interface {
	isDownstreamTlsContext_SessionTicketKeysType()
}

type DownstreamTlsContext_SessionTicketKeys struct {
	SessionTicketKeys *TlsSessionTicketKeys `protobuf:"bytes,4,opt,name=session_ticket_keys,json=sessionTicketKeys,oneof"`
}
type DownstreamTlsContext_SessionTicketKeysSdsSecretConfig struct {
	SessionTicketKeysSdsSecretConfig *SdsSecretConfig `protobuf:"bytes,5,opt,name=session_ticket_keys_sds_secret_config,json=sessionTicketKeysSdsSecretConfig,oneof"`
}

func (*DownstreamTlsContext_SessionTicketKeys) isDownstreamTlsContext_SessionTicketKeysType() {}
func (*DownstreamTlsContext_SessionTicketKeysSdsSecretConfig) isDownstreamTlsContext_SessionTicketKeysType() {
}

func (m *DownstreamTlsContext) GetSessionTicketKeysType() isDownstreamTlsContext_SessionTicketKeysType {
	if m != nil {
		return m.SessionTicketKeysType
	}
	return nil
}

func (m *DownstreamTlsContext) GetCommonTlsContext() *CommonTlsContext {
	if m != nil {
		return m.CommonTlsContext
	}
	return nil
}

func (m *DownstreamTlsContext) GetRequireClientCertificate() *google_protobuf1.BoolValue {
	if m != nil {
		return m.RequireClientCertificate
	}
	return nil
}

func (m *DownstreamTlsContext) GetRequireSni() *google_protobuf1.BoolValue {
	if m != nil {
		return m.RequireSni
	}
	return nil
}

func (m *DownstreamTlsContext) GetSessionTicketKeys() *TlsSessionTicketKeys {
	if x, ok := m.GetSessionTicketKeysType().(*DownstreamTlsContext_SessionTicketKeys); ok {
		return x.SessionTicketKeys
	}
	return nil
}

func (m *DownstreamTlsContext) GetSessionTicketKeysSdsSecretConfig() *SdsSecretConfig {
	if x, ok := m.GetSessionTicketKeysType().(*DownstreamTlsContext_SessionTicketKeysSdsSecretConfig); ok {
		return x.SessionTicketKeysSdsSecretConfig
	}
	return nil
}

// XXX_OneofFuncs is for the internal use of the proto package.
func (*DownstreamTlsContext) XXX_OneofFuncs() (func(msg proto.Message, b *proto.Buffer) error, func(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error), func(msg proto.Message) (n int), []interface{}) {
	return _DownstreamTlsContext_OneofMarshaler, _DownstreamTlsContext_OneofUnmarshaler, _DownstreamTlsContext_OneofSizer, []interface{}{
		(*DownstreamTlsContext_SessionTicketKeys)(nil),
		(*DownstreamTlsContext_SessionTicketKeysSdsSecretConfig)(nil),
	}
}

func _DownstreamTlsContext_OneofMarshaler(msg proto.Message, b *proto.Buffer) error {
	m := msg.(*DownstreamTlsContext)
	// session_ticket_keys_type
	switch x := m.SessionTicketKeysType.(type) {
	case *DownstreamTlsContext_SessionTicketKeys:
		b.EncodeVarint(4<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.SessionTicketKeys); err != nil {
			return err
		}
	case *DownstreamTlsContext_SessionTicketKeysSdsSecretConfig:
		b.EncodeVarint(5<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.SessionTicketKeysSdsSecretConfig); err != nil {
			return err
		}
	case nil:
	default:
		return fmt.Errorf("DownstreamTlsContext.SessionTicketKeysType has unexpected type %T", x)
	}
	return nil
}

func _DownstreamTlsContext_OneofUnmarshaler(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error) {
	m := msg.(*DownstreamTlsContext)
	switch tag {
	case 4: // session_ticket_keys_type.session_ticket_keys
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TlsSessionTicketKeys)
		err := b.DecodeMessage(msg)
		m.SessionTicketKeysType = &DownstreamTlsContext_SessionTicketKeys{msg}
		return true, err
	case 5: // session_ticket_keys_type.session_ticket_keys_sds_secret_config
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(SdsSecretConfig)
		err := b.DecodeMessage(msg)
		m.SessionTicketKeysType = &DownstreamTlsContext_SessionTicketKeysSdsSecretConfig{msg}
		return true, err
	default:
		return false, nil
	}
}

func _DownstreamTlsContext_OneofSizer(msg proto.Message) (n int) {
	m := msg.(*DownstreamTlsContext)
	// session_ticket_keys_type
	switch x := m.SessionTicketKeysType.(type) {
	case *DownstreamTlsContext_SessionTicketKeys:
		s := proto.Size(x.SessionTicketKeys)
		n += proto.SizeVarint(4<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case *DownstreamTlsContext_SessionTicketKeysSdsSecretConfig:
		s := proto.Size(x.SessionTicketKeysSdsSecretConfig)
		n += proto.SizeVarint(5<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case nil:
	default:
		panic(fmt.Sprintf("proto: unexpected type %T in oneof", x))
	}
	return n
}

// [#proto-status: experimental]
// [#not-implemented-hide:]
type SdsSecretConfig struct {
	// Name (FQDN, UUID, SPKI, SHA256, etc.) by which the secret can be uniquely referred to.
	// When both name and config are specified, then secret can be fetched and/or reloaded via SDS.
	// When only name is specified, then secret will be loaded from static resources [V2-API-DIFF].
	Name      string                           `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	SdsConfig *envoy_api_v2_core2.ConfigSource `protobuf:"bytes,2,opt,name=sds_config,json=sdsConfig" json:"sds_config,omitempty"`
}

func (m *SdsSecretConfig) Reset()                    { *m = SdsSecretConfig{} }
func (m *SdsSecretConfig) String() string            { return proto.CompactTextString(m) }
func (*SdsSecretConfig) ProtoMessage()               {}
func (*SdsSecretConfig) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{7} }

func (m *SdsSecretConfig) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *SdsSecretConfig) GetSdsConfig() *envoy_api_v2_core2.ConfigSource {
	if m != nil {
		return m.SdsConfig
	}
	return nil
}

// [#proto-status: experimental]
// [#not-implemented-hide:]
type Secret struct {
	// Name (FQDN, UUID, SPKI, SHA256, etc.) by which the secret can be uniquely referred to.
	Name string `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	// Types that are valid to be assigned to Type:
	//	*Secret_TlsCertificate
	//	*Secret_SessionTicketKeys
	Type isSecret_Type `protobuf_oneof:"type"`
}

func (m *Secret) Reset()                    { *m = Secret{} }
func (m *Secret) String() string            { return proto.CompactTextString(m) }
func (*Secret) ProtoMessage()               {}
func (*Secret) Descriptor() ([]byte, []int) { return fileDescriptor1, []int{8} }

type isSecret_Type interface {
	isSecret_Type()
}

type Secret_TlsCertificate struct {
	TlsCertificate *TlsCertificate `protobuf:"bytes,2,opt,name=tls_certificate,json=tlsCertificate,oneof"`
}
type Secret_SessionTicketKeys struct {
	SessionTicketKeys *TlsSessionTicketKeys `protobuf:"bytes,3,opt,name=session_ticket_keys,json=sessionTicketKeys,oneof"`
}

func (*Secret_TlsCertificate) isSecret_Type()    {}
func (*Secret_SessionTicketKeys) isSecret_Type() {}

func (m *Secret) GetType() isSecret_Type {
	if m != nil {
		return m.Type
	}
	return nil
}

func (m *Secret) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Secret) GetTlsCertificate() *TlsCertificate {
	if x, ok := m.GetType().(*Secret_TlsCertificate); ok {
		return x.TlsCertificate
	}
	return nil
}

func (m *Secret) GetSessionTicketKeys() *TlsSessionTicketKeys {
	if x, ok := m.GetType().(*Secret_SessionTicketKeys); ok {
		return x.SessionTicketKeys
	}
	return nil
}

// XXX_OneofFuncs is for the internal use of the proto package.
func (*Secret) XXX_OneofFuncs() (func(msg proto.Message, b *proto.Buffer) error, func(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error), func(msg proto.Message) (n int), []interface{}) {
	return _Secret_OneofMarshaler, _Secret_OneofUnmarshaler, _Secret_OneofSizer, []interface{}{
		(*Secret_TlsCertificate)(nil),
		(*Secret_SessionTicketKeys)(nil),
	}
}

func _Secret_OneofMarshaler(msg proto.Message, b *proto.Buffer) error {
	m := msg.(*Secret)
	// type
	switch x := m.Type.(type) {
	case *Secret_TlsCertificate:
		b.EncodeVarint(2<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.TlsCertificate); err != nil {
			return err
		}
	case *Secret_SessionTicketKeys:
		b.EncodeVarint(3<<3 | proto.WireBytes)
		if err := b.EncodeMessage(x.SessionTicketKeys); err != nil {
			return err
		}
	case nil:
	default:
		return fmt.Errorf("Secret.Type has unexpected type %T", x)
	}
	return nil
}

func _Secret_OneofUnmarshaler(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error) {
	m := msg.(*Secret)
	switch tag {
	case 2: // type.tls_certificate
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TlsCertificate)
		err := b.DecodeMessage(msg)
		m.Type = &Secret_TlsCertificate{msg}
		return true, err
	case 3: // type.session_ticket_keys
		if wire != proto.WireBytes {
			return true, proto.ErrInternalBadWireType
		}
		msg := new(TlsSessionTicketKeys)
		err := b.DecodeMessage(msg)
		m.Type = &Secret_SessionTicketKeys{msg}
		return true, err
	default:
		return false, nil
	}
}

func _Secret_OneofSizer(msg proto.Message) (n int) {
	m := msg.(*Secret)
	// type
	switch x := m.Type.(type) {
	case *Secret_TlsCertificate:
		s := proto.Size(x.TlsCertificate)
		n += proto.SizeVarint(2<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case *Secret_SessionTicketKeys:
		s := proto.Size(x.SessionTicketKeys)
		n += proto.SizeVarint(3<<3 | proto.WireBytes)
		n += proto.SizeVarint(uint64(s))
		n += s
	case nil:
	default:
		panic(fmt.Sprintf("proto: unexpected type %T in oneof", x))
	}
	return n
}

func init() {
	proto.RegisterType((*TlsParameters)(nil), "envoy.api.v2.auth.TlsParameters")
	proto.RegisterType((*TlsCertificate)(nil), "envoy.api.v2.auth.TlsCertificate")
	proto.RegisterType((*TlsSessionTicketKeys)(nil), "envoy.api.v2.auth.TlsSessionTicketKeys")
	proto.RegisterType((*CertificateValidationContext)(nil), "envoy.api.v2.auth.CertificateValidationContext")
	proto.RegisterType((*CommonTlsContext)(nil), "envoy.api.v2.auth.CommonTlsContext")
	proto.RegisterType((*CommonTlsContext_DeprecatedV1)(nil), "envoy.api.v2.auth.CommonTlsContext.DeprecatedV1")
	proto.RegisterType((*UpstreamTlsContext)(nil), "envoy.api.v2.auth.UpstreamTlsContext")
	proto.RegisterType((*DownstreamTlsContext)(nil), "envoy.api.v2.auth.DownstreamTlsContext")
	proto.RegisterType((*SdsSecretConfig)(nil), "envoy.api.v2.auth.SdsSecretConfig")
	proto.RegisterType((*Secret)(nil), "envoy.api.v2.auth.Secret")
	proto.RegisterEnum("envoy.api.v2.auth.TlsParameters_TlsProtocol", TlsParameters_TlsProtocol_name, TlsParameters_TlsProtocol_value)
}

func init() { proto.RegisterFile("envoy/api/v2/auth/cert.proto", fileDescriptor1) }

var fileDescriptor1 = []byte{
	// 1132 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xbc, 0x55, 0x4d, 0x6f, 0x1b, 0x45,
	0x18, 0xce, 0x7a, 0x9d, 0x34, 0x79, 0x9d, 0x8f, 0xcd, 0x34, 0xa8, 0x8b, 0x15, 0xd2, 0x74, 0x4b,
	0x44, 0x0f, 0x95, 0xdd, 0xb8, 0x6a, 0x25, 0x44, 0x29, 0x8a, 0x9d, 0x43, 0x44, 0x03, 0x81, 0xb5,
	0x13, 0xb5, 0x17, 0x46, 0x93, 0xf5, 0xc4, 0x1e, 0xbc, 0xde, 0x5d, 0x76, 0xc6, 0x9b, 0xfa, 0xca,
	0x4f, 0xe0, 0xcc, 0x0f, 0xe0, 0x37, 0x20, 0x21, 0xf1, 0x07, 0xf8, 0x13, 0x70, 0xe2, 0xc2, 0x99,
	0x23, 0x9a, 0xd9, 0x59, 0x7b, 0xfd, 0xd1, 0xc4, 0x12, 0x88, 0xdb, 0xcc, 0xfb, 0xf1, 0xbc, 0x33,
	0xf3, 0x3e, 0xef, 0x33, 0xb0, 0x4b, 0x83, 0x24, 0x1c, 0x56, 0x49, 0xc4, 0xaa, 0x49, 0xad, 0x4a,
	0x06, 0xa2, 0x5b, 0xf5, 0x68, 0x2c, 0x2a, 0x51, 0x1c, 0x8a, 0x10, 0x6d, 0x2b, 0x6f, 0x85, 0x44,
	0xac, 0x92, 0xd4, 0x2a, 0xd2, 0x5b, 0x9e, 0x4c, 0xf0, 0xc2, 0x98, 0x56, 0x2f, 0x09, 0xa7, 0x69,
	0x42, 0xf9, 0x60, 0xd6, 0xeb, 0x85, 0xc1, 0x15, 0xeb, 0x60, 0x1e, 0x0e, 0x62, 0x2f, 0x0b, 0xdb,
	0xeb, 0x84, 0x61, 0xc7, 0xa7, 0x55, 0xb5, 0xbb, 0x1c, 0x5c, 0x55, 0xaf, 0x63, 0x12, 0x45, 0x34,
	0xe6, 0xda, 0x7f, 0x2f, 0x21, 0x3e, 0x6b, 0x13, 0x41, 0xab, 0xd9, 0x42, 0x3b, 0x76, 0x3a, 0x61,
	0x27, 0x54, 0xcb, 0xaa, 0x5c, 0xa5, 0x56, 0xe7, 0x47, 0x13, 0x36, 0x5a, 0x3e, 0xff, 0x8a, 0xc4,
	0xa4, 0x4f, 0x05, 0x8d, 0x39, 0x1a, 0xc2, 0xae, 0xf0, 0x39, 0xee, 0xb3, 0x80, 0xf5, 0x07, 0x7d,
	0xac, 0xc2, 0xbc, 0xd0, 0xc7, 0x09, 0x8d, 0x39, 0x0b, 0x03, 0xdb, 0xd8, 0x37, 0x1e, 0x6d, 0xd6,
	0x1e, 0x57, 0x66, 0xee, 0x57, 0x99, 0xc0, 0x51, 0x3b, 0x9d, 0x5b, 0x87, 0x9f, 0xff, 0xfc, 0xd5,
	0x5c, 0xfe, 0xde, 0x28, 0x58, 0x86, 0xfb, 0xbe, 0xf0, 0xf9, 0x17, 0x29, 0x78, 0xe6, 0xbf, 0x48,
	0xa1, 0x47, 0xa5, 0xc9, 0xdb, 0xf9, 0xa5, 0x0b, 0xff, 0x45, 0xe9, 0x14, 0x7c, 0xba, 0xf4, 0x43,
	0xd8, 0xf0, 0x58, 0xd4, 0xa5, 0x31, 0xe6, 0x03, 0x26, 0x28, 0xb7, 0xcd, 0x7d, 0xf3, 0xd1, 0x9a,
	0xbb, 0x9e, 0x1a, 0x9b, 0xca, 0x86, 0xee, 0x43, 0x89, 0x7a, 0xed, 0x2e, 0xf6, 0x06, 0x71, 0x42,
	0xb9, 0x5d, 0x54, 0x21, 0x20, 0x4d, 0x0d, 0x65, 0x71, 0xce, 0xa0, 0x94, 0xab, 0x8d, 0xd6, 0x61,
	0xb5, 0x75, 0xda, 0xc4, 0x47, 0xe7, 0xad, 0x33, 0x6b, 0x09, 0x95, 0xe0, 0x4e, 0xeb, 0xb4, 0x99,
	0x1c, 0xe2, 0x27, 0x96, 0x31, 0xde, 0x1c, 0x5a, 0x85, 0xf1, 0xa6, 0x66, 0x99, 0xe3, 0xcd, 0x53,
	0xab, 0xe8, 0xfc, 0x5d, 0x80, 0xcd, 0x96, 0xcf, 0x1b, 0x34, 0x16, 0xec, 0x8a, 0x79, 0x44, 0x50,
	0xf4, 0x39, 0x6c, 0x7b, 0xe3, 0x2d, 0xf6, 0xba, 0x84, 0xa5, 0x4d, 0x29, 0xd5, 0x3e, 0x98, 0x7c,
	0x19, 0xc9, 0xa1, 0xca, 0x31, 0x11, 0xa4, 0xa9, 0x08, 0xe4, 0x5a, 0xb9, 0xbc, 0x86, 0x4c, 0x43,
	0x2f, 0xa1, 0x14, 0xc5, 0x2c, 0x91, 0x38, 0x3d, 0x3a, 0x54, 0xef, 0x7b, 0x2b, 0x0a, 0xe8, 0x8c,
	0x57, 0x74, 0x88, 0x3e, 0x86, 0xd5, 0x88, 0x70, 0x7e, 0x1d, 0xc6, 0x6d, 0xdb, 0x5c, 0x24, 0x79,
	0x14, 0x2e, 0x4b, 0x87, 0x1e, 0x8f, 0x30, 0x17, 0x24, 0xf2, 0xa9, 0x5d, 0x5c, 0xa8, 0xb4, 0xcc,
	0x68, 0xaa, 0x04, 0x84, 0x61, 0x97, 0xb3, 0x4e, 0x40, 0xdb, 0x38, 0xff, 0x1a, 0x82, 0xf5, 0x29,
	0x17, 0xa4, 0x1f, 0xd9, 0xcb, 0xfb, 0xe6, 0xed, 0x80, 0xe5, 0x14, 0x22, 0xf7, 0xbc, 0xad, 0x0c,
	0xc0, 0x39, 0x87, 0x9d, 0x96, 0xcf, 0x9b, 0x94, 0x4b, 0x7e, 0xb4, 0x98, 0xd7, 0xa3, 0xe2, 0x15,
	0x1d, 0x72, 0xf4, 0x29, 0x14, 0x7b, 0x74, 0xc8, 0x6d, 0x63, 0x81, 0x02, 0x9a, 0x7d, 0x3f, 0x18,
	0x85, 0x55, 0xc3, 0x55, 0x69, 0xce, 0x1f, 0x26, 0xec, 0xe6, 0xea, 0x5d, 0xa4, 0x43, 0xca, 0xc2,
	0xa0, 0x11, 0x06, 0x82, 0xbe, 0x15, 0xe8, 0x05, 0x80, 0x88, 0x07, 0x5c, 0xc8, 0x9b, 0x91, 0xc5,
	0x1a, 0xbb, 0xa6, 0x13, 0x1a, 0x04, 0x3d, 0x87, 0x7b, 0x09, 0x8d, 0xd9, 0xd5, 0x70, 0xe2, 0x59,
	0xba, 0x84, 0x77, 0xed, 0x82, 0xa2, 0xeb, 0x7b, 0xa9, 0x3b, 0x77, 0x84, 0x13, 0xc2, 0xbb, 0xe8,
	0x31, 0x20, 0x9d, 0xc7, 0xa3, 0x1e, 0xc3, 0xbc, 0x4b, 0x6a, 0xcf, 0x9e, 0xeb, 0x21, 0xb0, 0x52,
	0x4f, 0x33, 0xea, 0xb1, 0xa6, 0xb2, 0xa3, 0x67, 0xa3, 0x2a, 0x7c, 0x70, 0xf9, 0x2d, 0xf5, 0x04,
	0x26, 0xbe, 0xc0, 0x01, 0xe9, 0x53, 0x3d, 0x14, 0x3b, 0x3a, 0x25, 0xf5, 0x1e, 0xf9, 0xe2, 0x4b,
	0xd2, 0x97, 0xd4, 0xbd, 0x1b, 0xd3, 0xef, 0x06, 0x2c, 0xa6, 0x38, 0xdf, 0xfb, 0x65, 0x75, 0xc7,
	0x72, 0x25, 0x55, 0xb6, 0x4a, 0xa6, 0x6c, 0x95, 0x7a, 0x18, 0xfa, 0x17, 0xc4, 0x1f, 0x50, 0x77,
	0x5b, 0xa7, 0x9d, 0x8d, 0xfb, 0xdf, 0x83, 0x0f, 0x33, 0xac, 0x1b, 0x79, 0xb0, 0x72, 0x2b, 0xf8,
	0x03, 0x8d, 0xd3, 0x7c, 0x27, 0x17, 0x50, 0x15, 0x4c, 0x2f, 0xf6, 0xed, 0x3b, 0x8b, 0x34, 0x43,
	0x46, 0x3a, 0xbf, 0x14, 0xc1, 0x6a, 0x84, 0xfd, 0x7e, 0x18, 0xc8, 0xe9, 0xd5, 0x9d, 0xfd, 0x0c,
	0x40, 0xca, 0x5b, 0x24, 0x85, 0x8a, 0xeb, 0xce, 0xee, 0xdf, 0x26, 0x66, 0xee, 0x9a, 0xd0, 0x5b,
	0x8e, 0x5e, 0x83, 0x25, 0x01, 0x72, 0x17, 0xe5, 0xaa, 0xab, 0xa5, 0xda, 0x83, 0xf9, 0x30, 0xb9,
	0xcb, 0x8c, 0xa9, 0x68, 0x19, 0xee, 0x96, 0x98, 0xf0, 0x71, 0x14, 0x80, 0x33, 0x85, 0x8c, 0x79,
	0x9b, 0x63, 0x4e, 0xbd, 0x98, 0x0a, 0x9c, 0xfe, 0x43, 0xdc, 0x5e, 0x51, 0xb5, 0x9c, 0x39, 0xb5,
	0x9a, 0x6d, 0xde, 0x54, 0xb1, 0x0d, 0x15, 0xea, 0xee, 0x4d, 0x16, 0x98, 0x72, 0x73, 0xf4, 0x0d,
	0xa0, 0x64, 0xc4, 0x7c, 0x89, 0x2f, 0x1f, 0x48, 0x4b, 0x48, 0x75, 0x0e, 0xfe, 0x4d, 0x13, 0xe3,
	0x6e, 0x27, 0x33, 0x43, 0x74, 0x00, 0x9b, 0xc4, 0x8f, 0x82, 0xd1, 0x17, 0x92, 0x89, 0xf5, 0x86,
	0xb4, 0x66, 0xfa, 0xcc, 0xd1, 0x1b, 0xd8, 0x68, 0xd3, 0x28, 0xa6, 0x12, 0xb7, 0x8d, 0x93, 0x43,
	0x4d, 0xc5, 0x27, 0xf3, 0x4e, 0x30, 0xd5, 0xcd, 0xca, 0xf1, 0x28, 0xf1, 0xe2, 0xb0, 0x5e, 0xb0,
	0x0d, 0x77, 0xbd, 0x9d, 0xb3, 0x94, 0x5f, 0xc0, 0x7a, 0x3e, 0x42, 0x0e, 0x98, 0x9c, 0x91, 0xa9,
	0x53, 0x49, 0x12, 0xac, 0xb9, 0x16, 0xf1, 0xc5, 0x51, 0xfe, 0x60, 0xce, 0x10, 0xd0, 0x79, 0xc4,
	0x45, 0x4c, 0x49, 0x3f, 0x47, 0xa0, 0xaf, 0x01, 0x79, 0xea, 0x18, 0x58, 0x35, 0x4b, 0xbf, 0x5a,
	0x4a, 0xa4, 0x87, 0x0b, 0x9c, 0xd9, 0xb5, 0xbc, 0x69, 0x4e, 0x5a, 0x60, 0xf2, 0x80, 0x29, 0xe5,
	0x5f, 0x73, 0xe5, 0xd2, 0xf9, 0xcb, 0x84, 0x9d, 0xe3, 0xf0, 0x3a, 0xf8, 0x3f, 0xaa, 0xbf, 0x86,
	0x72, 0x36, 0xc4, 0x9e, 0xcf, 0x68, 0x20, 0xf2, 0x0c, 0xd4, 0xdf, 0xd1, 0x4d, 0xa3, 0x6b, 0xeb,
	0xec, 0x86, 0x4a, 0xce, 0xff, 0x92, 0x9f, 0x40, 0x69, 0x24, 0x0f, 0x01, 0xd3, 0xcc, 0xba, 0x09,
	0x0a, 0x32, 0x15, 0x08, 0x18, 0x7a, 0x03, 0x77, 0x79, 0xaa, 0xfb, 0x58, 0x28, 0xe1, 0xc7, 0x4a,
	0xf1, 0xd3, 0x3f, 0xea, 0xa3, 0xf9, 0xa3, 0x36, 0xf3, 0x51, 0x9c, 0x2c, 0xb9, 0xdb, 0x7c, 0xe6,
	0xf7, 0x18, 0xc0, 0xc1, 0x1c, 0xe8, 0xd9, 0x61, 0xd3, 0x4c, 0x5c, 0x60, 0xd6, 0x4e, 0x96, 0xdc,
	0xfd, 0x99, 0x3a, 0x53, 0x31, 0xf5, 0x32, 0xd8, 0xf3, 0xca, 0x8a, 0x61, 0x44, 0x1d, 0x0a, 0x5b,
	0x53, 0xe1, 0x08, 0x41, 0x51, 0x89, 0x79, 0x4a, 0x4f, 0xb5, 0x46, 0x2f, 0x01, 0xe4, 0x29, 0xf5,
	0xf1, 0xd2, 0xde, 0xdc, 0x9f, 0x23, 0x85, 0x29, 0x44, 0xf6, 0x33, 0xf1, 0x36, 0x4f, 0x0d, 0xce,
	0x6f, 0x06, 0xac, 0xa4, 0x45, 0xe6, 0xc2, 0x9f, 0xc2, 0xd6, 0x94, 0x02, 0xe9, 0x1a, 0xb7, 0x4b,
	0xdb, 0xc9, 0x92, 0xbb, 0x39, 0xa9, 0x37, 0xef, 0xea, 0xa0, 0xf9, 0xef, 0x3b, 0x58, 0x5f, 0x81,
	0xa2, 0x7c, 0xb6, 0x7a, 0xf1, 0xa7, 0xdf, 0xf7, 0x8c, 0xcb, 0x15, 0x45, 0xa5, 0xa7, 0xff, 0x04,
	0x00, 0x00, 0xff, 0xff, 0xe7, 0x34, 0xa8, 0xf5, 0x0d, 0x0c, 0x00, 0x00,
}
